module Main where

import PrioQueue

data MyType = MyType {name :: String, age :: Int}
 deriving (Eq, Show)

instance Ord MyType where
 compare x y = compare (age x) (age y)

main = do
 let pq0 = empty
     pq1 = insert (MyType "Daniel" 34) pq0;
     pq2 = insert (MyType "Anders" 29) pq1;
     pq3 = insert (MyType "Tora" 32) pq2;
     pq4 = insert (MyType "Anna" 38) pq3;
     pq5 = insert (MyType "Sara" 26) pq4;
 let (x, pq6) = deleteMin pq5
 putStrLn $ show x
 let (x, pq7) = deleteMin pq6
 putStrLn $ show x
 let (x, pq8) = deleteMin pq7
 putStrLn $ show x
 let (x, pq9) = deleteMin pq8
 putStrLn $ show x
 let (x, pq10) = deleteMin pq9
 putStrLn $ show x
